#include <QApplication>
#include <QDesktopWidget>
#include <QTableView>
#include <QScriptEngine>

#include "proxies.h"

int main(int argc, char *argv[])
{
    QApplication app(argc, argv);

    QTableView view{};
    Model model{};

    QScriptEngine engine;
    engine.evaluate("function data(row, col) { return \"script \" + row + col }");

    ScriptProxy *proxy = new ScriptProxy{};

    engine.globalObject().setProperty("scriptProxy", engine.newQObject(proxy));
    engine.evaluate("scriptProxy.callback = data");
    // или
    // proxy->setCallback(engine.globalObject().property("data"));

    proxy->setParent(&model);
    proxy->setSourceModel(&model);

    view.setModel(proxy);
    view.show();
    return app.exec();
}
