#include "proxies.h"

#include <QString>
#include <QScriptEngine>

Model::Model(QObject *parent) : QAbstractTableModel(parent) {}

int Model::rowCount(const QModelIndex &parent) const
{
    if( parent.isValid() ) return 0;
    return 3;
}

int Model::columnCount(const QModelIndex &parent) const
{
    if( parent.isValid() ) return 0;
    return 3;
}

QVariant Model::data(const QModelIndex &index, int role) const
{
    if( role != Qt::DisplayRole ) {
      return QVariant();
    }
    return QString("model ") + QString::number(index.row()) + QString::number(index.column());
}

QScriptValue ScriptProxy::callback() const
{
    return callback_;
}

void ScriptProxy::setCallback(const QScriptValue &cb)
{
    callback_ = cb;
}

QVariant ScriptProxy::data(const QModelIndex &index, int role) const
{
    if( Qt::DisplayRole != role ) {
        return QVariant();
    }
    if( !callback_.isValid() ) {
        return QIdentityProxyModel::data(index, role);
    } else {
        QScriptEngine *engine = callback_.engine();
        QScriptValue global = engine->globalObject();

        QScriptValue row{index.row()};
        QScriptValue column{index.column()};
        QScriptValueList args;
        args << row << column;

        QScriptValue callback_copy = callback_;
        return callback_copy.call(global, args).toVariant();
    }
}
