#ifndef PROXIES_H
#define PROXIES_H

#include <QAbstractTableModel>
#include <QIdentityProxyModel>
#include <QScriptValue>

class Model : public QAbstractTableModel {
    Q_OBJECT
public:
    Model(QObject *parent = nullptr);

public:
    virtual int rowCount(const QModelIndex &parent = QModelIndex()) const;
    virtual int columnCount(const QModelIndex &parent = QModelIndex()) const;
    virtual QVariant data(const QModelIndex &index, int role = Qt::DisplayRole) const;
};

class ScriptProxy : public QIdentityProxyModel {
    Q_OBJECT
    Q_PROPERTY(QScriptValue callback READ callback WRITE setCallback)

    QScriptValue callback_;
public:
    QScriptValue callback() const;
    void setCallback(const QScriptValue &cb);


    virtual QVariant data(const QModelIndex &index, int role) const;
};

#endif //PROXIES_H
